/**
 * This class contains unit tests for validating the behavior of Apex classes
 * and triggers.
 *
 * Unit tests are class methods that verify whether a particular piece
 * of code is working properly. Unit test methods take no arguments,
 * commit no data to the database, and are flagged with the testMethod
 * keyword in the method definition.
 *
 * All test methods in an organization are executed whenever Apex code is deployed
 * to a production organization to confirm correctness, ensure code
 * coverage, and prevent regressions. All Apex classes are
 * required to have at least 75% code coverage in order to be deployed
 * to a production organization. In addition, all triggers must have some code coverage.
 * 
 * The @isTest class annotation indicates this class only contains test
 * methods. Classes defined with the @isTest annotation do not count against
 * the organization size limit for all Apex scripts.
 *
 * See the Apex Language Reference for more information about Testing and Code Coverage.
 */
  /*------------------------------------------------------------
Author:        Yen Le
Company:       Thirdwave
Description:   a test class created to validate the EquipmentMissingFormBulkClose,
               EquipmentMissingFormEdit, and EquipmentMissingFormView
History: 	   09-Mar-17 Miro Zelina added test methods for Well Event and Facility add missing form
               06-jul-17 Miro Zelina added test methods for System & Sub-System add missing form
               28-Jul-17 Miro Zelina updated test for SAP Support User for bulk close
               
------------------------------------------------------------*/
@isTest
private class EquipmentMissingFormTest { 

    static Field__c field;
    static Route__c route; 
    
    static void createSampleData()
    {
        Business_Unit__c businessUnit = new Business_Unit__c(Name = 'Test Business Unit');
        insert businessUnit;

        Business_Department__c  businessDepartment = BusinessDepartmentTestData.createBusinessDepartment('Test Business Department');    
        insert businessDepartment;

        Operating_District__c operatingDistrict = OperatingDistrictTestData.createOperatingDistrict('Test Field', businessDepartment.Id, businessUnit.Id);
        insert operatingDistrict;
        
        Id recordTypeId = [Select Id From RecordType Where SObjectType = 'Field__c' And Name = 'HOG - Control Room Centre Record'].Id;
        
        field = FieldTestData.createField('Test Field Control Centre', operatingDistrict.Id, recordTypeId);
        insert field;

        route = RouteTestData.createRoute('999');
        insert route; 
         
        
    }
    static testMethod void testAddEquipmentFormLocation() {
        
        createSampleData();
        Location__c wellLocation = LocationTestData.createLocation('Location for testing', route.Id, field.Id);
        insert wellLocation;
        
        //test create a new Add Equipment Form
        PageReference pageRef = Page.EquipmentMissingFormEdit;
        Test.setCurrentPage(pageRef);
        pageRef.getParameters().put('locId', wellLocation.Id);
        
        Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
        ApexPages.Standardcontroller stdCtrl = new ApexPages.Standardcontroller(addingForm);
        EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
        addingForm = addingFormCtrl.form; 
        
        System.assertEquals(addingForm.Location__c, wellLocation.Id);
        System.assertEquals(addingForm.Status__c, 'Open');
        System.assertEquals(addingForm.Equipment_Status__c, 'Missing');
        
        System.assert(addingFormCtrl.attachment.Id  == null);
        System.assert(addingFormCtrl.serialPlate.Id  == null);
        //test validation error: Manufacturer is required
        try
        {
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must enter a value');
        }
        //Serial No is required
        try
        {
            addingForm.Manufacturer__c = 'TANK';
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must enter a value');
        }
        //Serial Plate of Asset is required
        try
        {
            addingForm.Manufacturer_Serial_No__c = '121342';
            addingFormCtrl.serialPlate.Body = null;
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must attach a file');
        }
        //Location is required
        try
        {
            addingForm.Location__c = null;
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'Please go to a Well Location / Facility / Well Event / System or Sub-System detail page and click the "Add Equipment Form" button on the Equipment related list.');
        }
        addingForm.Manufacturer__c = 'TANK';
        addingForm.Manufacturer_Serial_No__c = '123142';
        addingForm.Status__c ='Open';
        addingForm.Equipment_Status__c = 'Missing';
        addingForm.Location__c = wellLocation.Id;
        addingForm.Description__c = 'Description';
        addingForm.Model_Number__c = 'Test';
        addingFormCtrl.serialPlate.Name = 'upload attachment';
        addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
        addingFormCtrl.attachment.Name = 'upload attachment 1';
        addingFormCtrl.attachment.Body = Blob.valueOf('testing');
        
        addingFormCtrl.save();
        //the record is save successfull
        System.assert(stdCtrl.getId() != null);
        
        //test edit Data Update form
        addingForm = [select Comments__c, Id, Equipment_Status__c, 
                    Manufacturer__c, Manufacturer_Serial_No__c, Location__c,
                    Model_Number__c, Name, Status__c, Tag_Number__c, Serial_Plate_Of_Asset__c, Attachment__c 
                    from Equipment_Missing_Form__c where Id =: stdCtrl.getId()];
                    
        List<Attachment> attList = [select Id, Name from Attachment where ParentId =: addingForm.Id];
        System.assert(attList.size() == 2);
                    
        PageReference editPage = Page.EquipmentMissingFormEdit;
        Test.setCurrentPage(editPage);
        editPage.getParameters().clear();
        editPage.getParameters().put('id', addingForm.Id);
        editPage.getParameters().put('locId', null);
        editPage.getParameters().put('retURL', wellLocation.Id);
        
        stdCtrl = new ApexPages.Standardcontroller(addingForm);
        EquipmentMissingFormControllerX addingFormEditCtrl = new EquipmentMissingFormControllerX(stdCtrl);
        addingForm = addingFormEditCtrl.form;
        addingFormEditCtrl.serialPlate = attList[0];
        addingFormEditCtrl.attachment = attList[1];
        System.assertEquals(addingForm.Manufacturer__c, 'TANK');
      //  System.assert(addingFormEditCtrl.attachment.Id != null);
        
        addingFormEditCtrl.attId = attList[0].Id;
        addingFormEditCtrl.DeletePhoto();
        addingFormEditCtrl.form.Comments__c = 'delete attachment';
        addingFormEditCtrl.save();
        
        //close the Request
        addingFormEditCtrl.CloseRequest();
        
        addingForm = [select id, Status__c from Equipment_Missing_Form__c where Id =: addingForm.Id];
        System.assertEquals(addingForm.Status__c, 'Closed');
        
    }
    
    
        static testMethod void testAddEquipmentFormEvent() {
        
        createSampleData();
        Location__c wellLocation = LocationTestData.createLocation('Location for testing', route.Id, field.Id);
        insert wellLocation;
        
        Well_Event__c wellEvent = LocationTestData.createEvent('Test Well Event', wellLocation.Id);    
        insert wellEvent;
        
        //test create a new Add Equipment Form
        PageReference pageRef = Page.EquipmentMissingFormEdit;
        Test.setCurrentPage(pageRef);
        pageRef.getParameters().put('eventId', wellEvent.Id);
        
        Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
        ApexPages.Standardcontroller stdCtrl = new ApexPages.Standardcontroller(addingForm);
        EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
        addingForm = addingFormCtrl.form; 
        
        System.assertEquals(addingForm.Well_Event__c, wellEvent.Id);
        System.assertEquals(addingForm.Status__c, 'Open');
        System.assertEquals(addingForm.Equipment_Status__c, 'Missing');
        
        System.assert(addingFormCtrl.attachment.Id  == null);
        System.assert(addingFormCtrl.serialPlate.Id  == null);
        //test validation error: Manufacturer is required
        try
        {
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must enter a value');
        }
        //Serial No is required
        try
        {
            addingForm.Manufacturer__c = 'TANK';
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must enter a value');
        }
        //Serial Plate of Asset is required
        try
        {
            addingForm.Manufacturer_Serial_No__c = '121342';
            addingFormCtrl.serialPlate.Body = null;
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must attach a file');
        }
        //Well event is required
        try
        {
            addingForm.Well_Event__c = null;
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'Please go to a Well Location / Facility / Well Event / System or Sub-System detail page and click the "Add Equipment Form" button on the Equipment related list.');
        }
        addingForm.Manufacturer__c = 'TANK';
        addingForm.Manufacturer_Serial_No__c = '123142';
        addingForm.Status__c ='Open';
        addingForm.Equipment_Status__c = 'Missing';
        addingForm.Well_Event__c = wellEvent.Id;
        addingForm.Description__c = 'Description';
        addingForm.Model_Number__c = 'Test';
        addingFormCtrl.serialPlate.Name = 'upload attachment';
        addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
        addingFormCtrl.attachment.Name = 'upload attachment 1';
        addingFormCtrl.attachment.Body = Blob.valueOf('testing');
        
        addingFormCtrl.save();
        //the record is save successfull
        System.assert(stdCtrl.getId() != null);
        
        //test edit Data Update form
        addingForm = [select Comments__c, Id, Equipment_Status__c, 
                    Manufacturer__c, Manufacturer_Serial_No__c, Location__c,
                    Model_Number__c, Name, Status__c, Tag_Number__c, Serial_Plate_Of_Asset__c, Attachment__c 
                    from Equipment_Missing_Form__c where Id =: stdCtrl.getId()];
                    
        List<Attachment> attList = [select Id, Name from Attachment where ParentId =: addingForm.Id];
        System.assert(attList.size() == 2);
                    
        PageReference editPage = Page.EquipmentMissingFormEdit;
        Test.setCurrentPage(editPage);
        editPage.getParameters().clear();
        editPage.getParameters().put('id', addingForm.Id);
        editPage.getParameters().put('eventId', null);
        editPage.getParameters().put('retURL', wellEvent.Id);
        
        stdCtrl = new ApexPages.Standardcontroller(addingForm);
        EquipmentMissingFormControllerX addingFormEditCtrl = new EquipmentMissingFormControllerX(stdCtrl);
        addingForm = addingFormEditCtrl.form;
        addingFormEditCtrl.serialPlate = attList[0];
        addingFormEditCtrl.attachment = attList[1];
        System.assertEquals(addingForm.Manufacturer__c, 'TANK');
        
        addingFormEditCtrl.attId = attList[0].Id;
        addingFormEditCtrl.DeletePhoto();
        addingFormEditCtrl.form.Comments__c = 'delete attachment';
        addingFormEditCtrl.save();
        
        //close the Request
        addingFormEditCtrl.CloseRequest();
        
        addingForm = [select id, Status__c from Equipment_Missing_Form__c where Id =: addingForm.Id];
        System.assertEquals(addingForm.Status__c, 'Closed');
        
    }
    
    static testMethod void testAddEquipmentFormSystem() {
        
        createSampleData();
        
        System__c sys = LocationTestData.createSystem('Test System');    
        
        //test create a new Add Equipment Form
        PageReference pageRef = Page.EquipmentMissingFormEdit;
        Test.setCurrentPage(pageRef);
        pageRef.getParameters().put('sysId', sys.Id);
        
        Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
        ApexPages.Standardcontroller stdCtrl = new ApexPages.Standardcontroller(addingForm);
        EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
        addingForm = addingFormCtrl.form; 
        
        System.assertEquals(addingForm.System__c, sys.Id);
        System.assertEquals(addingForm.Status__c, 'Open');
        System.assertEquals(addingForm.Equipment_Status__c, 'Missing');
        
        System.assert(addingFormCtrl.attachment.Id  == null);
        System.assert(addingFormCtrl.serialPlate.Id  == null);
        //test validation error: Manufacturer is required
        try
        {
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must enter a value');
        }
        //Serial No is required
        try
        {
            addingForm.Manufacturer__c = 'TANK';
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must enter a value');
        }
        //Serial Plate of Asset is required
        try
        {
            addingForm.Manufacturer_Serial_No__c = '121342';
            addingFormCtrl.serialPlate.Body = null;
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must attach a file');
        }
        //Well event is required
        try
        {
            addingForm.System__c = null;
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'Please go to a Well Location / Facility / Well Event / System or Sub-System detail page and click the "Add Equipment Form" button on the Equipment related list.');
        }
        addingForm.Manufacturer__c = 'TANK';
        addingForm.Manufacturer_Serial_No__c = '123142';
        addingForm.Status__c ='Open';
        addingForm.Equipment_Status__c = 'Missing';
        addingForm.System__c = sys.Id;
        addingForm.Description__c = 'Description';
        addingForm.Model_Number__c = 'Test';
        addingFormCtrl.serialPlate.Name = 'upload attachment';
        addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
        addingFormCtrl.attachment.Name = 'upload attachment 1';
        addingFormCtrl.attachment.Body = Blob.valueOf('testing');
        
        addingFormCtrl.save();
        //the record is save successfull
        System.assert(stdCtrl.getId() != null);
        
        //test edit Data Update form
        addingForm = [select Comments__c, Id, Equipment_Status__c, 
                    Manufacturer__c, Manufacturer_Serial_No__c, Location__c,
                    Model_Number__c, Name, Status__c, Tag_Number__c, Serial_Plate_Of_Asset__c, Attachment__c 
                    from Equipment_Missing_Form__c where Id =: stdCtrl.getId()];
                    
        List<Attachment> attList = [select Id, Name from Attachment where ParentId =: addingForm.Id];
        System.assert(attList.size() == 2);
                    
        PageReference editPage = Page.EquipmentMissingFormEdit;
        Test.setCurrentPage(editPage);
        editPage.getParameters().clear();
        editPage.getParameters().put('id', addingForm.Id);
        editPage.getParameters().put('sysId', null);
        editPage.getParameters().put('retURL', sys.Id);
        
        stdCtrl = new ApexPages.Standardcontroller(addingForm);
        EquipmentMissingFormControllerX addingFormEditCtrl = new EquipmentMissingFormControllerX(stdCtrl);
        addingForm = addingFormEditCtrl.form;
        addingFormEditCtrl.serialPlate = attList[0];
        addingFormEditCtrl.attachment = attList[1];
        System.assertEquals(addingForm.Manufacturer__c, 'TANK');
        
        addingFormEditCtrl.attId = attList[0].Id;
        addingFormEditCtrl.DeletePhoto();
        addingFormEditCtrl.form.Comments__c = 'delete attachment';
        addingFormEditCtrl.save();
        
        //close the Request
        addingFormEditCtrl.CloseRequest();
        
        addingForm = [select id, Status__c from Equipment_Missing_Form__c where Id =: addingForm.Id];
        System.assertEquals(addingForm.Status__c, 'Closed');
        
    }
    
    static testMethod void testAddEquipmentFormSubSystem() {
        
        createSampleData();

        Sub_System__c subSys = LocationTestData.createSubSystem('Test SubSystem');    
        
        //test create a new Add Equipment Form
        PageReference pageRef = Page.EquipmentMissingFormEdit;
        Test.setCurrentPage(pageRef);
        pageRef.getParameters().put('subSysId', subSys.Id);
        
        Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
        ApexPages.Standardcontroller stdCtrl = new ApexPages.Standardcontroller(addingForm);
        EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
        addingForm = addingFormCtrl.form; 
        
        System.assertEquals(addingForm.Sub_System__c, subSys.Id);
        System.assertEquals(addingForm.Status__c, 'Open');
        System.assertEquals(addingForm.Equipment_Status__c, 'Missing');
        
        System.assert(addingFormCtrl.attachment.Id  == null);
        System.assert(addingFormCtrl.serialPlate.Id  == null);
        //test validation error: Manufacturer is required
        try
        {
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must enter a value');
        }
        //Serial No is required
        try
        {
            addingForm.Manufacturer__c = 'TANK';
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must enter a value');
        }
        //Serial Plate of Asset is required
        try
        {
            addingForm.Manufacturer_Serial_No__c = '121342';
            addingFormCtrl.serialPlate.Body = null;
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must attach a file');
        }
        //Well event is required
        try
        {
            addingForm.Sub_System__c = null;
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'Please go to a Well Location / Facility / Well Event / System or Sub-System detail page and click the "Add Equipment Form" button on the Equipment related list.');
        }
        addingForm.Manufacturer__c = 'TANK';
        addingForm.Manufacturer_Serial_No__c = '123142';
        addingForm.Status__c ='Open';
        addingForm.Description__c = 'Description';
        addingForm.Model_Number__c = 'Test';
        addingForm.Equipment_Status__c = 'Missing';
        addingForm.Sub_System__c = subSys.Id;
        addingFormCtrl.serialPlate.Name = 'upload attachment';
        addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
        addingFormCtrl.attachment.Name = 'upload attachment 1';
        addingFormCtrl.attachment.Body = Blob.valueOf('testing');
        
        addingFormCtrl.save();
        //the record is save successfull
        System.assert(stdCtrl.getId() != null);
        
        //test edit Data Update form
        addingForm = [select Comments__c, Id, Equipment_Status__c, 
                    Manufacturer__c, Manufacturer_Serial_No__c, Location__c,
                    Model_Number__c, Name, Status__c, Tag_Number__c, Serial_Plate_Of_Asset__c, Attachment__c 
                    from Equipment_Missing_Form__c where Id =: stdCtrl.getId()];
                    
        List<Attachment> attList = [select Id, Name from Attachment where ParentId =: addingForm.Id];
        System.assert(attList.size() == 2);
                    
        PageReference editPage = Page.EquipmentMissingFormEdit;
        Test.setCurrentPage(editPage);
        editPage.getParameters().clear();
        editPage.getParameters().put('id', addingForm.Id);
        editPage.getParameters().put('subSysId', null);
        editPage.getParameters().put('retURL', subSys.Id);
        
        stdCtrl = new ApexPages.Standardcontroller(addingForm);
        EquipmentMissingFormControllerX addingFormEditCtrl = new EquipmentMissingFormControllerX(stdCtrl);
        addingForm = addingFormEditCtrl.form;
        addingFormEditCtrl.serialPlate = attList[0];
        addingFormEditCtrl.attachment = attList[1];
        System.assertEquals(addingForm.Manufacturer__c, 'TANK');
        
        addingFormEditCtrl.attId = attList[0].Id;
        addingFormEditCtrl.DeletePhoto();
        addingFormEditCtrl.form.Comments__c = 'delete attachment';
        addingFormEditCtrl.save();
        
        //close the Request
        addingFormEditCtrl.CloseRequest();
        
        addingForm = [select id, Status__c from Equipment_Missing_Form__c where Id =: addingForm.Id];
        System.assertEquals(addingForm.Status__c, 'Closed');
        
    }

    static testMethod void testAddEquipmentFormFEL() {
        
        createSampleData();

        Functional_Equipment_Level__c fel = LocationTestData.createFEL('Test FEL');    
        
        //test create a new Add Equipment Form
        PageReference pageRef = Page.EquipmentMissingFormEdit;
        Test.setCurrentPage(pageRef);
        pageRef.getParameters().put('felId', fel.Id);
        
        Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
        ApexPages.Standardcontroller stdCtrl = new ApexPages.Standardcontroller(addingForm);
        EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
        addingForm = addingFormCtrl.form; 
        
        System.assertEquals(addingForm.Functional_Equipment_Level__c, fel.Id);
        System.assertEquals(addingForm.Status__c, 'Open');
        System.assertEquals(addingForm.Equipment_Status__c, 'Missing');
        
        System.assert(addingFormCtrl.attachment.Id  == null);
        System.assert(addingFormCtrl.serialPlate.Id  == null);
        //test validation error: Manufacturer is required
        try
        {
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must enter a value');
        }
        //Serial No is required
        try
        {
            addingForm.Manufacturer__c = 'TANK';
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must enter a value');
        }
        //Serial Plate of Asset is required
        try
        {
            addingForm.Manufacturer_Serial_No__c = '121342';
            addingForm.Manufacturer__c = 'TANK';
            addingFormCtrl.serialPlate.Body = null;
            addingForm.Description__c = 'Description';
            addingForm.Model_Number__c = 'Test';
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must attach a file');
        }
        
        try
        {
            addingForm.Functional_Equipment_Level__c = null;
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'Please go to a Well Location / Facility / Well Event / System or Sub-System detail page and click the "Add Equipment Form" button on the Equipment related list.');
        }
        addingForm.Manufacturer__c = 'TANK';
        addingForm.Manufacturer_Serial_No__c = '123142';
        addingForm.Status__c ='Open';
        addingForm.Equipment_Status__c = 'Missing';
        addingForm.Functional_Equipment_Level__c = fel.Id;
        addingForm.Description__c = 'Description';
        addingForm.Model_Number__c = 'Test';
        addingFormCtrl.serialPlate.Name = 'upload attachment';
        addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
        addingFormCtrl.attachment.Name = 'upload attachment 1';
        addingFormCtrl.attachment.Body = Blob.valueOf('testing');
        
        addingFormCtrl.save();
        //the record is save successfull
        System.assert(stdCtrl.getId() != null);
        
        //test edit Data Update form
        addingForm = [select Comments__c, Id, Equipment_Status__c, 
                    Manufacturer__c, Manufacturer_Serial_No__c, Location__c,
                    Model_Number__c, Name, Status__c, Tag_Number__c, Serial_Plate_Of_Asset__c, Attachment__c 
                    from Equipment_Missing_Form__c where Id =: stdCtrl.getId()];
                    
        List<Attachment> attList = [select Id, Name from Attachment where ParentId =: addingForm.Id];
        System.assert(attList.size() == 2);
                    
        PageReference editPage = Page.EquipmentMissingFormEdit;
        Test.setCurrentPage(editPage);
        editPage.getParameters().clear();
        editPage.getParameters().put('id', addingForm.Id);
        editPage.getParameters().put('felId', null);
        editPage.getParameters().put('retURL', fel.Id);
        
        stdCtrl = new ApexPages.Standardcontroller(addingForm);
        EquipmentMissingFormControllerX addingFormEditCtrl = new EquipmentMissingFormControllerX(stdCtrl);
        addingForm = addingFormEditCtrl.form;
        addingFormEditCtrl.serialPlate = attList[0];
        addingFormEditCtrl.attachment = attList[1];
        System.assertEquals(addingForm.Manufacturer__c, 'TANK');
        
        addingFormEditCtrl.attId = attList[0].Id;
        addingFormEditCtrl.DeletePhoto();
        addingFormEditCtrl.form.Comments__c = 'delete attachment';
        addingFormEditCtrl.save();
        
        //close the Request
        addingFormEditCtrl.CloseRequest();
        
        addingForm = [select id, Status__c from Equipment_Missing_Form__c where Id =: addingForm.Id];
        System.assertEquals(addingForm.Status__c, 'Closed');
        
    }

    static testMethod void testAddEquipmentFormYARD() {
        
        createSampleData();

        Yard__c yard = LocationTestData.createYard('Test Yard');    
        
        //test create a new Add Equipment Form
        PageReference pageRef = Page.EquipmentMissingFormEdit;
        Test.setCurrentPage(pageRef);
        pageRef.getParameters().put('yardId', yard.Id);
        
        Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
        ApexPages.Standardcontroller stdCtrl = new ApexPages.Standardcontroller(addingForm);
        EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
        addingForm = addingFormCtrl.form; 
        
        System.assertEquals(addingForm.Yard__c, yard.Id);
        System.assertEquals(addingForm.Status__c, 'Open');
        System.assertEquals(addingForm.Equipment_Status__c, 'Missing');
        
        System.assert(addingFormCtrl.attachment.Id  == null);
        System.assert(addingFormCtrl.serialPlate.Id  == null);
        //test validation error: Manufacturer is required
        try
        {
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must enter a value');
        }
        //Serial No is required
        try
        {
            addingForm.Manufacturer__c = 'TANK';
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must enter a value');
        }
        //Serial Plate of Asset is required
        try
        {
            addingForm.Manufacturer_Serial_No__c = '121342';
            addingFormCtrl.serialPlate.Body = null;
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must attach a file');
        }
        
        try
        {
            addingForm.Yard__c = null;
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'Please go to a Well Location / Facility / Well Event / System or Sub-System detail page and click the "Add Equipment Form" button on the Equipment related list.');
        }
        addingForm.Manufacturer__c = 'TANK';
        addingForm.Manufacturer_Serial_No__c = '123142';
        addingForm.Status__c ='Open';
        addingForm.Equipment_Status__c = 'Missing';
        addingForm.Yard__c = yard.Id;
        addingForm.Description__c = 'Description';
        addingForm.Model_Number__c = 'Test';
        addingFormCtrl.serialPlate.Name = 'upload attachment';
        addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
        addingFormCtrl.attachment.Name = 'upload attachment 1';
        addingFormCtrl.attachment.Body = Blob.valueOf('testing');
        
        addingFormCtrl.save();
        //the record is save successfull
        System.assert(stdCtrl.getId() != null);
        
        //test edit Data Update form
        addingForm = [select Comments__c, Id, Equipment_Status__c, 
                    Manufacturer__c, Manufacturer_Serial_No__c, Location__c,
                    Model_Number__c, Name, Status__c, Tag_Number__c, Serial_Plate_Of_Asset__c, Attachment__c 
                    from Equipment_Missing_Form__c where Id =: stdCtrl.getId()];
                    
        List<Attachment> attList = [select Id, Name from Attachment where ParentId =: addingForm.Id];
        System.assert(attList.size() == 2);
                    
        PageReference editPage = Page.EquipmentMissingFormEdit;
        Test.setCurrentPage(editPage);
        editPage.getParameters().clear();
        editPage.getParameters().put('id', addingForm.Id);
        editPage.getParameters().put('yardId', null);
        editPage.getParameters().put('retURL', yard.Id);
        
        stdCtrl = new ApexPages.Standardcontroller(addingForm);
        EquipmentMissingFormControllerX addingFormEditCtrl = new EquipmentMissingFormControllerX(stdCtrl);
        addingForm = addingFormEditCtrl.form;
        addingFormEditCtrl.serialPlate = attList[0];
        addingFormEditCtrl.attachment = attList[1];
        System.assertEquals(addingForm.Manufacturer__c, 'TANK');
        
        addingFormEditCtrl.attId = attList[0].Id;
        addingFormEditCtrl.DeletePhoto();
        addingFormEditCtrl.form.Comments__c = 'delete attachment';
        addingFormEditCtrl.save();
        
        //close the Request
        addingFormEditCtrl.CloseRequest();
        
        addingForm = [select id, Status__c from Equipment_Missing_Form__c where Id =: addingForm.Id];
        System.assertEquals(addingForm.Status__c, 'Closed');
        
    }
    
    static testMethod void testAddEquipmentFormFacility() {
        
        createSampleData();
        
        Facility__c facility = FacilityTestData.createFacility('Test Facility', route.Id, field.Id);
		insert facility;
        
        //test create a new Add Equipment Form
        PageReference pageRef = Page.EquipmentMissingFormEdit;
        Test.setCurrentPage(pageRef);
        pageRef.getParameters().put('facId', facility.Id);
        
        Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
        ApexPages.Standardcontroller stdCtrl = new ApexPages.Standardcontroller(addingForm);
        EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
        addingForm = addingFormCtrl.form; 
        
        System.assertEquals(addingForm.Facility__c, facility.Id);
        System.assertEquals(addingForm.Status__c, 'Open');
        System.assertEquals(addingForm.Equipment_Status__c, 'Missing');
        
        System.assert(addingFormCtrl.attachment.Id  == null);
        System.assert(addingFormCtrl.serialPlate.Id  == null);
        //test validation error: Manufacturer is required
        try
        {
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must enter a value');
        }
        //Serial No is required
        try
        {
            addingForm.Manufacturer__c = 'TANK';
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must enter a value');
        }
        //Serial Plate of Asset is required
        try
        {
            addingForm.Manufacturer_Serial_No__c = '121342';
            addingFormCtrl.serialPlate.Body = null;
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'You must attach a file');
        }
        //Well event is required
        try
        {
            addingForm.facility__c = null;
            addingFormCtrl.save();
        }
        catch(Exception e)
        {
            System.assert(false, 'Please go to a Well Location detail page and click the "Add Equipment Form" button on the Equipment related list.');
        }
        addingForm.Manufacturer__c = 'TANK';
        addingForm.Manufacturer_Serial_No__c = '123142';
        addingForm.Status__c ='Open';
        addingForm.Equipment_Status__c = 'Missing';
        addingForm.Facility__c = facility.Id;
        addingForm.Description__c = 'Description';
        addingForm.Model_Number__c = 'Test';
        addingFormCtrl.serialPlate.Name = 'upload attachment';
        addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
        addingFormCtrl.attachment.Name = 'upload attachment 1';
        addingFormCtrl.attachment.Body = Blob.valueOf('testing');
        
        addingFormCtrl.save();
        //the record is save successfull
        System.assert(stdCtrl.getId() != null);
        
        //test edit Data Update form
        addingForm = [select Comments__c, Id, Equipment_Status__c, 
                    Manufacturer__c, Manufacturer_Serial_No__c, Location__c,
                    Model_Number__c, Name, Status__c, Tag_Number__c, Serial_Plate_Of_Asset__c, Attachment__c 
                    from Equipment_Missing_Form__c where Id =: stdCtrl.getId()];
                    
        List<Attachment> attList = [select Id, Name from Attachment where ParentId =: addingForm.Id];
        System.assert(attList.size() == 2);
                    
        PageReference editPage = Page.EquipmentMissingFormEdit;
        Test.setCurrentPage(editPage);
        editPage.getParameters().clear();
        editPage.getParameters().put('id', addingForm.Id);
        editPage.getParameters().put('facId', null);
        editPage.getParameters().put('retURL', facility.Id);
        
        stdCtrl = new ApexPages.Standardcontroller(addingForm);
        EquipmentMissingFormControllerX addingFormEditCtrl = new EquipmentMissingFormControllerX(stdCtrl);
        addingForm = addingFormEditCtrl.form;
        addingFormEditCtrl.serialPlate = attList[0];
        addingFormEditCtrl.attachment = attList[1];
        System.assertEquals(addingForm.Manufacturer__c, 'TANK');
        
        addingFormEditCtrl.attId = attList[0].Id;
        addingFormEditCtrl.DeletePhoto();
        addingFormEditCtrl.form.Comments__c = 'delete attachment';
        addingFormEditCtrl.save();
        
        //close the Request
        addingFormEditCtrl.CloseRequest();
        
        addingForm = [select id, Status__c from Equipment_Missing_Form__c where Id =: addingForm.Id];
        System.assertEquals(addingForm.Status__c, 'Closed');
        
    }
    
    
    static testMethod void testAddEquipmentBulkClose()
    {
        
        User sapSupportLeadUser = EquipmentTestData.createUser('SAP Support - Lead','Standard HOG - General User','SAP_Support_LeadUser@test.com'); 

        System.runAs(sapSupportLeadUser)
        {
        
            createSampleData();
            Location__c wellLocation = LocationTestData.createLocation('Location for testing', route.Id, field.Id);
            insert wellLocation;
          
            //create bulk of "Open" Add Equipment form
            List<Equipment_Missing_Form__c> formList = new List<Equipment_Missing_Form__c>();
            for(integer i=0; i< 3; i++)
            {
                Equipment_Missing_Form__c form = new Equipment_Missing_Form__c();
                form.Location__c = wellLocation.Id;
                form.Status__c = 'Open';
                form.Equipment_Status__c = 'Missing';
                form.Manufacturer__c = 'SAMSUNG';
                form.Manufacturer_Serial_No__c = '46464';
                form.Serial_plate_of_asset__c = '0024253647442';
                formList.add(form);
            }
            insert formList;
            
         
            
            formList = [select Comments__c, Id, Equipment_Status__c, Location__c,
                        Manufacturer__c, Manufacturer_Serial_No__c, 
                        Model_Number__c, Name, Status__c, Tag_Number__c, Serial_Plate_Of_Asset__c, Attachment__c,
                        Well_Event__c, System__c, Sub_System__c, Functional_Equipment_Level__c, Yard__c, Facility__c 
                        from Equipment_Missing_Form__c where Location__c =: wellLocation.Id];
            
                        
            ApexPages.StandardSetController stdcon = new ApexPages.StandardSetController(new List<Equipment_Missing_Form__c>());
            stdcon.setSelected(new List<Equipment_Missing_Form__c>());
            EquipmentMissingFormBulkCloseControllerX setCtrl;
            //display error when no Form is selected
            try
            {
                setCtrl = new EquipmentMissingFormBulkCloseControllerX(stdcon);
            }
            catch(Exception e)
            {
                System.assert(false, 'Please select at least one Add Equipment Form');
            }
            System.debug(stdcon.getSelected().size() == 0);
            
            stdcon = new ApexPages.StandardSetController(formList);
            stdcon.setSelected(formList);
            setCtrl = new EquipmentMissingFormBulkCloseControllerX(stdcon);
            
            system.assertEquals(1, setCtrl.CurrentIndex); 
            system.assertNotEquals(null, setCtrl.CurrentForm); 
            system.assertEquals(3, setCtrl.selectedList.Size()); 
                
                
            Equipment_Missing_Form__c CurrentForm = setCtrl.CurrentForm;
            Attachment att = new Attachment();
            att.Name ='test attachment';
            att.body = Blob.valueOf('file content');
            att.ParentId = CurrentForm.Id;
            insert att;
            
            Attachment att2 = new Attachment();
            att2.Name ='test attachment';
            att2.body = Blob.valueOf('file content');
            att2.ParentId = CurrentForm.Id;
            insert att2;
            
            CurrentForm.Attachment__c = att2.Id;
            CurrentForm.Serial_plate_of_asset__c = att.Id;
            update CurrentForm;
            
            System.assert(setCtrl.serialPlate.Id  != null);
            System.assert(setCtrl.attachment.Id  != null);
            
            Equipment_Missing_Form__c Form2 = setCtrl.selectedList[1];
            Equipment_Missing_Form__c Form3 = setCtrl.selectedList[2];
                
            system.assertEquals(false, setCtrl.getHasPreviousForm()); 
            system.assertEquals(true, setCtrl.getHasNextForm());            
    
            setCtrl.NextForm();
            setCtrl.serialPlate = null;
            setCtrl.attachment = null;
            system.assertEquals(2, setCtrl.CurrentIndex); 
            system.assertEquals(Form2 , setCtrl.CurrentForm); 
            system.assertEquals(true, setCtrl.getHasPreviousForm()); 
            system.assertEquals(true, setCtrl.getHasNextForm()); 
    
            setCtrl.NextForm();
            system.assertEquals(3, setCtrl.CurrentIndex);             
            system.assertEquals(Form3 , setCtrl.CurrentForm); 
            system.assertEquals(true, setCtrl.getHasPreviousForm()); 
            system.assertEquals(false, setCtrl.getHasNextForm());                        
    
            //lets try to go over the last form
            setCtrl.NextForm();
            system.assertEquals(3, setCtrl.CurrentIndex); //still 3            
            system.assertEquals(Form3 , setCtrl.CurrentForm); 
            system.assertEquals(true, setCtrl.getHasPreviousForm()); 
            system.assertEquals(false, setCtrl.getHasNextForm());  
    
            setCtrl.PreviousForm();
            system.assertEquals(2, setCtrl.CurrentIndex); 
            system.assertEquals(Form2 , setCtrl.CurrentForm); 
            system.assertEquals(true, setCtrl.getHasPreviousForm()); 
            system.assertEquals(true, setCtrl.getHasNextForm()); 
                
            setCtrl.CloseForm();
            Form2 = [select Id, Status__c from Equipment_Missing_Form__c where Id=: Form2.id];
            System.assertEquals(Form2.Status__c, 'Closed');


            setCtrl.Exit();
        
        }
    }
    
        static testMethod void testAddEquipmentBulkCloseNonSAPSupportuser()
    {
        
        //user is not SAP Support Lead - will fail
        User HOGUser = EquipmentTestData.createUser('Heavy Oil & Gas','Standard HOG - General User','SAP_Support_LeadUser@test.com'); 

        System.runAs(HOGUser)
        {
            createSampleData();
            Location__c wellLocation = LocationTestData.createLocation('Location for testing', route.Id, field.Id);
            insert wellLocation;
          
            //create bulk of "Open" Add Equipment form
            List<Equipment_Missing_Form__c> formList = new List<Equipment_Missing_Form__c>();
            for(integer i=0; i< 3; i++)
            {
                Equipment_Missing_Form__c form = new Equipment_Missing_Form__c();
                form.Location__c = wellLocation.Id;
                form.Status__c = 'Open';
                form.Equipment_Status__c = 'Missing';
                form.Manufacturer__c = 'SAMSUNG';
                form.Manufacturer_Serial_No__c = '46464';
                form.Serial_plate_of_asset__c = '0024253647442';
                formList.add(form);
            }
            insert formList;
            
         
            
            formList = [select Comments__c, Id, Equipment_Status__c, Location__c,
                        Manufacturer__c, Manufacturer_Serial_No__c, 
                        Model_Number__c, Name, Status__c, Tag_Number__c, Serial_Plate_Of_Asset__c, Attachment__c,
                        Well_Event__c, System__c, Sub_System__c, Functional_Equipment_Level__c, Yard__c, Facility__c
                        from Equipment_Missing_Form__c where Location__c =: wellLocation.Id];
            
                        
            ApexPages.StandardSetController stdcon = new ApexPages.StandardSetController(new List<Equipment_Missing_Form__c>());
            stdcon.setSelected(new List<Equipment_Missing_Form__c>());
            EquipmentMissingFormBulkCloseControllerX setCtrl;
            //display error when no Form is selected
            try
            {
                setCtrl = new EquipmentMissingFormBulkCloseControllerX(stdcon);
            }
            catch(Exception e)
            {
                System.assert(false, 'Please select at least one Add Equipment Form');
            }
            
            stdcon = new ApexPages.StandardSetController(formList);
            stdcon.setSelected(formList);
            setCtrl = new EquipmentMissingFormBulkCloseControllerX(stdcon);
            
            List<Apexpages.Message> msgs = ApexPages.getMessages();
            boolean b = false;
            
            for (Apexpages.Message msg : msgs){
                 
                if (msg.getDetail().contains('Only SAP Support Lead, HOG - Administrator or System Administrator can process.')){ 
                    
                    b = true;
                }
            }
            
            system.assert(b);   //Assert the Page Message was Properly Displayed
        
        }
    }
}